﻿using Microsoft.Owin;
using Owin;
using Microsoft.Owin.Cors;
using GrapeCity.Documents.Pdf.ViewerSupportApi.Controllers;
using GrapeCity.Documents.Pdf.ViewerSupportApi.Connection;
using System;
using Microsoft.AspNet.SignalR;
using GrapeCity.Documents.Pdf.ViewerSupportApi.Models;

[assembly: OwinStartup(typeof(GcPdfViewerSupportApiDemo.Startup))]
namespace GcPdfViewerSupportApiDemo
{
    public class Startup
    {

        const int MAX_MESSAGE_SIZE = 268435456/*256MB*/;

        static Startup()
        {
            Licensing.AddLicenseKeys();
        }
        public void Configuration(IAppBuilder app)
        {
            app.UseCors(CorsOptions.AllowAll);
            GcPdfViewerHub.Configure(app);
            GcPdfViewerController.Settings.VerifyToken += VerifyAuthToken;
            
        }

        private void VerifyAuthToken(object sender, VerifyTokenEventArgs e)
        {
            // Here is an example of how you can validate the authentication token
            // provided during viewer initialization - new GcPdfViewer(selector, { supportApi: { token: "support-api-demo" }});.
            string token = e.Token;
            if (string.IsNullOrEmpty(token) || !token.StartsWith("support-api-demo"))
            {
                e.Reject = true;
            }
        }
    }
}
